// -*- C++ -*-
/*!
 * @file  VoiceIn.cpp
 * @brief Sample component
 * $Date$
 *
 * $Id$
 */

#include "VoiceIn.h"
#include "../libsound.h"

// Module specification
// <rtc-template block="module_spec">
static const char* voicein_spec[] =
  {
    "implementation_id", "VoiceIn",
    "type_name",         "VoiceIn",
    "description",       "Sample component",
    "version",           "0.1",
    "vendor",            "AIST",
    "category",          "Generic",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    "conf.default.int_param0", "0",
    "conf.default.int_param1", "1",
    "conf.default.double_param0", "3.14",
    "conf.default.double_param1", "9.99",
    "conf.default.str_param0", "hoge",
    "conf.default.str_param1", "foo",

    ""
  };
// </rtc-template>

VoiceIn::VoiceIn(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_outOut("out", m_out),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  // Set OutPort buffer
  registerOutPort("out", m_outOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

VoiceIn::~VoiceIn()
{
}


/*RTC::ReturnCode_t VoiceIn::onInitialize()
{
  m_out.data.length(LENGTH*RATE*CHANNELS*2);
  return RTC::RTC_OK;
}*/



/*
RTC::ReturnCode_t VoiceIn::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VoiceIn::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VoiceIn::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

RTC::ReturnCode_t VoiceIn::onActivated(RTC::UniqueId ec_id)
{
  std::cout << "start activate\n";
  m_out.data.length(LENGTH*RATE*CHANNELS*2);
  std::cout << "end length set\n";
  record_init();
  std::cout << "end record init\n";
  return RTC::RTC_OK;
}



RTC::ReturnCode_t VoiceIn::onDeactivated(RTC::UniqueId ec_id)
{
  record_end();
  return RTC::RTC_OK;
}


RTC::ReturnCode_t VoiceIn::onExecute(RTC::UniqueId ec_id)
{
  std::cout << "Execute start\n";
  record_copybuf((char *)&(m_out.data[0]));
  std::cout << "copy buf end\n";
  m_outOut.write();
  std::cout << "write end\n";
  std::cout << "Execute end\n";
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t VoiceIn::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VoiceIn::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VoiceIn::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VoiceIn::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VoiceIn::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void VoiceInInit(RTC::Manager* manager)
  {
    RTC::Properties profile(voicein_spec);
    manager->registerFactory(profile,
                             RTC::Create<VoiceIn>,
                             RTC::Delete<VoiceIn>);
  }
  
};


