// -*- C++ -*-
/*!
 * @file  VoiceOut.cpp
 * @brief Sample component
 * $Date$
 *
 * $Id$
 */

#include "VoiceOut.h"
#include "../libsound.h"

// Module specification
// <rtc-template block="module_spec">
static const char* voiceout_spec[] =
  {
    "implementation_id", "VoiceOut",
    "type_name",         "VoiceOut",
    "description",       "Sample component",
    "version",           "0.1",
    "vendor",            "AIST",
    "category",          "Generic",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    "conf.default.int_param0", "0",
    "conf.default.int_param1", "1",
    "conf.default.double_param0", "3.14",
    "conf.default.double_param1", "9.99",
    "conf.default.str_param0", "hoge",
    "conf.default.str_param1", "foo",

    ""
  };
// </rtc-template>

VoiceOut::VoiceOut(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_inIn("in", m_in),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("in", m_inIn);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

VoiceOut::~VoiceOut()
{
}


/*RTC::ReturnCode_t VoiceOut::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable

  m_in.data.length(LENGTH*RATE*CHANNELS*2);
  return RTC::RTC_OK;
}*/



/*
RTC::ReturnCode_t VoiceOut::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VoiceOut::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VoiceOut::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t VoiceOut::onActivated(RTC::UniqueId ec_id)
{
  std::cout << "start activate\n";
  m_in.data.length(LENGTH*RATE*CHANNELS*2);
  std::cout << "end length set\n";
  play_init();
  std::cout << "end play init\n";
  return RTC::RTC_OK;
}



RTC::ReturnCode_t VoiceOut::onDeactivated(RTC::UniqueId ec_id)
{
  play_end();
  return RTC::RTC_OK;
}



RTC::ReturnCode_t VoiceOut::onExecute(RTC::UniqueId ec_id)
{
  if(m_inIn.isNew()) {
    std::cout << "start execute\n";
    m_inIn.read();
    std::cout << "read end\n";
    play_copybuf((char *)&(m_in.data[0]));
    std::cout << "copy buf end\n";
    std::cout << "end execute\n";
  }
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t VoiceOut::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VoiceOut::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VoiceOut::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VoiceOut::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VoiceOut::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void VoiceOutInit(RTC::Manager* manager)
  {
    RTC::Properties profile(voiceout_spec);
    manager->registerFactory(profile,
                             RTC::Create<VoiceOut>,
                             RTC::Delete<VoiceOut>);
  }
  
};


