/*----------------------------------------------
  Voice In p ĐvOCu
  ----------------------------------------------*/

#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/soundcard.h>
#include <string.h>
#include <pthread.h>

#include "libsound.h"

static int fd;	/* t@CfBXNv^ */
static int endflag;
static unsigned char wp, rp; /* f[^i[pobt@ */
static unsigned char carry;
static unsigned short buf[LENGTH*RATE*CHANNELS]; 
static unsigned short rbuf[STRAGE][LENGTH*RATE*CHANNELS]; 
static pthread_t routine_thread;

void *
play_routine(void *param)
{
  int ret;
  int count;    /* f[^ǂݍ݂̍ۂ̃G[pϐ */
  char *rbufp; /* f[^i[pobt@ */

  /****************************/
  /*  t@C̓ǂݍ  */
  /****************************/


  /* f[^ǂ݂ */
  while(endflag == 0) {
    while(wp + carry * STRAGE <= rp){
	    fprintf(stderr, "carry:%d wp:%d rp:%d\n", carry, wp, rp);
    }

    rbufp = (char *)rbuf[rp];
    count = sizeof(unsigned short)*LENGTH*RATE*CHANNELS; ret = 0;
    do {
      ret = write(fd, rbufp, count);
      if(ret == -1) {
        fprintf(stderr, "write error\n");
        return 0;
      }
      count -= ret;
      rbufp += ret;
    } while (count != 0);
    ++rp;
    if(rp == STRAGE) {
      rp = 0;
      --carry;
    }
  }
  return 0;
}

/*[Ũobt@write֐*/
void
play_copybuf(char * src)
{

  memcpy((char *)rbuf[wp], src, LENGTH*RATE*CHANNELS*sizeof(unsigned short));

  ++wp;
  if(wp == STRAGE) {
    wp = 0;
    ++carry;
  }
}

int
play_init(void)
{
  int arg;	/* ioctl calls sȂ߂̕ϐ*/
  int status;   /* Xe[^Xi[pϐ */

  /* TEhfoCX̃I[v */
  /* ݐp (O_WRONLY) ŊJ */
  fd = open("/dev/dsp", O_WRONLY);
  if(fd < 0){  /* G[ */
    perror("open of /dev/dsp failed");
    return 1;
  }

  /****************************/
  /*    p[^̐ݒ      */
  /****************************/

  /* TvTCYݒ肷 */
  arg = SIZE;
  status = ioctl(fd, SOUND_PCM_WRITE_BITS, &arg);
  if (status == -1){  /* G[ */
    perror("SOUND_PCM_WRITE_BITS ioctl failed");
    return 1;
  }

  /* XeImݒ肷 */
  arg = CHANNELS; 
  status = ioctl(fd, SOUND_PCM_WRITE_CHANNELS, &arg);
  if (status == -1){  /* G[ */
    perror("SOUND_PCM_WRITE_CHANNELS ioctl failed");
    return 1;
  }

  /* TvOCgݒ肷 */
  arg = RATE;
  status = ioctl(fd, SOUND_PCM_WRITE_RATE, &arg);
  if (status == -1){  /* G[ */
    perror("SOUND_PCM_WRITE_WRITE ioctl failed");
    return 1;
  }

  wp = 0; rp = 0; carry = 0; endflag = 0;
  if(pthread_create(&routine_thread, NULL, play_routine, NULL) < 0) {
    perror("pthread_create is failed");
  }

  return 0;
}

int
play_file(char *path)
{
  int status;   /* Xe[^Xi[pϐ */
  int count;    /* f[^ǂݍ݂̍ۂ̃G[pϐ */
  char *bufp; /* f[^i[pobt@ */
  FILE   *fp;   /* t@Cݗpt@C|C^ */

  /****************************/
  /*  t@C̓ǂݍ  */
  /****************************/
  
  /* t@Cǂ݂ݐpŃI[v */
  fp = fopen(path, "rb");
  if(fp == NULL){  /* G[ */
    fprintf(stderr, "file open failed %s\n", path);
    return 1;
  }
  /* f[^ǂ݂ */
  count = fread(buf, sizeof(short), LENGTH*RATE*CHANNELS, fp);
  
  /* t@CN[Y */
  fclose(fp);
  
  /****************************/
  /*    t@C̍Đ    */
  /****************************/
  count *= sizeof(unsigned short);
  /* writeR}hgpăfoCXɏ */
  bufp = (char *)buf;
  while (count>0) {
    status = write(fd, bufp, count);
    if (status==-1) {  /* G[ */
      perror("wrote wrong number of bytes");
      return 1;
    }
    count -= status;
    bufp += status;
  }

  return 0;
}

void
play_end(void)
{
  endflag = 1;
  pthread_join(routine_thread, NULL);
  close(fd);
}

