/*----------------------------------------------
  Voice In p@^vOCu
  ----------------------------------------------*/

#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/soundcard.h>
#include <string.h>
#include <pthread.h>

#include "libsound.h"

static int fd;	/* t@CfBXNv^ */
static int endflag;
static unsigned char wp, rp; /* f[^i[pobt@ */
static unsigned char carry;
static unsigned short buf[LENGTH*RATE*CHANNELS]; 
static unsigned short rbuf[STRAGE][LENGTH*RATE*CHANNELS]; 
static pthread_t routine_thread;

void *
record_routine(void *param)
{
  int r;
  int count;    /* f[^ǂݍ݂̍ۂ̃G[pϐ */
  char *rbufp; /* f[^i[pobt@ */

  /****************************/
  /*  t@C̓ǂݍ  */
  /****************************/
  
  /* f[^ǂ݂ */
  while(endflag == 0) {
    rbufp = (char *)rbuf[rp];
    count = LENGTH*RATE*CHANNELS*sizeof(unsigned short); r = 0;
    fprintf(stderr, "start rec%d\n", rp);
    do {
      r = read(fd, rbufp, count);
      if(r == 0) {
        fprintf(stderr, "read error\n");
        return 0;
      }
      count -= r;
      rbufp += r;
    } while (count != 0);
    ++rp;
    if(rp == STRAGE) {
      rp = 0;
      ++carry;
    }
  }

  return 0;
}

/*[Ũobt@write֐*/
void
record_copybuf(char * dest)
{
  while(wp >= rp + carry * STRAGE) {
	  fprintf(stderr, "wp:%d, rp %d\n", wp, rp);
  }

  memcpy(dest, (char *)rbuf[wp], LENGTH*RATE*CHANNELS*sizeof(unsigned short));

  ++wp;
  if(wp == STRAGE) {
    wp = 0;
    --carry;
  }
}

int
record_init(void)
{
  int arg;	/* ioctl calls sȂ߂̕ϐ*/
  int status;   /* Xe[^Xi[pϐ */

  /* TEhfoCX̃I[v */
  fd = open("/dev/dsp", O_RDONLY);
  if(fd < 0){  /* G[ */
    perror("open of /dev/audio failed");
    return 1;
  }

  /****************************/
  /*    p[^̐ݒ      */
  /****************************/

  /* TvTCYݒ肷 */
  arg = SIZE;
  status = ioctl(fd, SOUND_PCM_WRITE_BITS, &arg);
  if (status == -1){  /* G[ */
    perror("SOUND_PCM_WRITE_BITS ioctl failed");
    return 1;
  }

  /* XeImݒ肷 */
  arg = CHANNELS; 
  status = ioctl(fd, SOUND_PCM_WRITE_CHANNELS, &arg);
  if (status == -1){  /* G[ */
    perror("SOUND_PCM_WRITE_CHANNELS ioctl failed");
    return 1;
  }

  /* TvOCgݒ肷 */
  arg = RATE;
  status = ioctl(fd, SOUND_PCM_WRITE_RATE, &arg);
  if (status == -1){  /* G[ */
    perror("SOUND_PCM_WRITE_WRITE ioctl failed");
    return 1;
  }

  wp = 0; rp =0; carry = 0; endflag= 0;
  if(pthread_create(&routine_thread, NULL, record_routine, 0) < 0) {
    perror("pthread_create is failed");
  }
  
  return 0;
}

int
record_file(char* path)
{
  FILE * fp;
  char *bufp; /* f[^i[pobt@ */
  int r;
  int count;    /* f[^ǂݍ݂̍ۂ̃G[pϐ */

  /****************************/
  /*  t@C̏  */
  /****************************/
  
  fp = fopen(path, "wb");
  if(fp == NULL){  /* G[ */
    perror("file open failed");
    return 1;
  }

  bufp = (char *)buf;

  /* f[^ǂ݂ */
  count = 0;
	do {
	  r = read(fd, bufp, LENGTH*RATE*CHANNELS - count);
		if(r == 0) {
			fprintf(stderr, "read error\n");
			return 1;
		}
		count += r;
		bufp += r;
 	 } while(count != LENGTH*RATE*CHANNELS);

  count = 0;
  while((count += fwrite(&buf[count], sizeof(short), LENGTH*RATE*CHANNELS, fp)) != LENGTH*RATE*CHANNELS);
  if(count != LENGTH*RATE*CHANNELS){  /* G[ */
    perror("file read failed");
    printf("read count is %d\n", count);
    return 1;
  }
  
  /* t@CN[Y */
  fclose(fp);
  
  return 1;
}

void
record_end(void)
{
  endflag = 1;
  pthread_join(routine_thread, NULL);
  close(fd);
}

